import "GaranStuff.MoorMap.ColorPicker"
-- need to create the options window
optionsPanel = Turbine.UI.Control()

	optionsPanel:SetSize(510,510);

	optionsPanel.HadErrors=false;
	optionsPanel:SetBackColor(backColor);

	optionsPanel.OptionsCaption=Turbine.UI.Label();
	optionsPanel.OptionsCaption:SetParent(optionsPanel);
	optionsPanel.OptionsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	optionsPanel.OptionsCaption:SetForeColor(headingsColor);
	optionsPanel.OptionsCaption:SetSize(optionsPanel:GetWidth(),20);
	optionsPanel.OptionsCaption:SetPosition(0,0);
	optionsPanel.OptionsCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	optionsPanel.OptionsCaption:SetText(Resource[language][4]..":");

	optionsPanel.LanguageCaption=Turbine.UI.Label();
	optionsPanel.LanguageCaption:SetParent(optionsPanel);
	optionsPanel.LanguageCaption:SetPosition(10,optionsPanel.OptionsCaption:GetTop()+optionsPanel.OptionsCaption:GetHeight()+9);
	optionsPanel.LanguageCaption:SetSize(optionsPanel:GetWidth()-301,18);
	optionsPanel.LanguageCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.LanguageCaption:SetForeColor(fontColor);
	optionsPanel.LanguageCaption:SetText(Resource[language][5]..":");

	optionsPanel.LanguageList=GaranStuff.MoorMap.DropDownList();
	optionsPanel.LanguageList:SetParent(optionsPanel);
	optionsPanel.LanguageList:SetPosition(optionsPanel.LanguageCaption:GetLeft()+optionsPanel.LanguageCaption:GetWidth()+2,optionsPanel.LanguageCaption.GetTop()-3);
	optionsPanel.LanguageList:SetSize(optionsPanel:GetWidth()-(optionsPanel.LanguageCaption:GetWidth()+optionsPanel.LanguageCaption:GetLeft())-65,20);
	optionsPanel.LanguageList:SetBorderColor(trimColor);
	optionsPanel.LanguageList:SetBackColor(backColor);
	optionsPanel.LanguageList:SetCurrentBackColor(backColor);
	optionsPanel.LanguageList:SetDropRows(5);

	local tmpLanguage;
	for tmpLanguage in pairs(Resource) do
		optionsPanel.LanguageList:AddItem(Resource[tmpLanguage][1],tmpLanguage);
	end

	optionsPanel.LanguageList.SelectedIndexChanged = function ()
		optionsPanel:SetLanguage(optionsPanel.LanguageList:GetValue());
	end

	optionsPanel.WorldCaption=Turbine.UI.Label();
	optionsPanel.WorldCaption:SetParent(optionsPanel);
	optionsPanel.WorldCaption:SetPosition(10,optionsPanel.LanguageCaption:GetTop()+optionsPanel.LanguageCaption:GetHeight()+9);
	optionsPanel.WorldCaption:SetSize(optionsPanel:GetWidth()-301,18);
	optionsPanel.WorldCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.WorldCaption:SetForeColor(fontColor);
	optionsPanel.WorldCaption:SetText(Resource[language][149]..":");

	optionsPanel.WorldList=GaranStuff.MoorMap.DropDownList();
	optionsPanel.WorldList:SetParent(optionsPanel);
	optionsPanel.WorldList:SetPosition(optionsPanel.WorldCaption:GetLeft()+optionsPanel.WorldCaption:GetWidth()+2,optionsPanel.WorldCaption.GetTop()-3);
	optionsPanel.WorldList:SetSize(optionsPanel:GetWidth()-(optionsPanel.WorldCaption:GetWidth()+optionsPanel.WorldCaption:GetLeft())-65,20);
	optionsPanel.WorldList:SetBorderColor(trimColor);
	optionsPanel.WorldList:SetBackColor(backColor);
	optionsPanel.WorldList:SetCurrentBackColor(backColor);
	optionsPanel.WorldList:SetDropRows(5);

	optionsPanel.WorldList:AddItem("Arkenstone","Arkenstone");
	optionsPanel.WorldList:AddItem("Brandywine","Brandywine");
	optionsPanel.WorldList:AddItem("Crickhollow","Crickhollow");
	optionsPanel.WorldList:AddItem("Dwarrowdelf","Dwarrowdelf");
	optionsPanel.WorldList:AddItem("Elendilmir","Elendilmir");
	optionsPanel.WorldList:AddItem("Firefoot","Firefoot");
	optionsPanel.WorldList:AddItem("Gladden","Gladden");
	optionsPanel.WorldList:AddItem("Imladris","Imladris");
	optionsPanel.WorldList:AddItem("Landroval","Landroval");
	optionsPanel.WorldList:AddItem("Meneldor","Meneldor");
	optionsPanel.WorldList:AddItem("Nimrodel","Nimrodel");
	optionsPanel.WorldList:AddItem("Riddermark","Riddermark");
	optionsPanel.WorldList:AddItem("Silverlode","Silverlode");
	optionsPanel.WorldList:AddItem("Vilya","Vilya");
	optionsPanel.WorldList:AddItem("Windfola","Windfola");
	optionsPanel.WorldList:AddItem("[DE] Anduin","_DE_Anduin");
	optionsPanel.WorldList:AddItem("[DE] Gwaihir","_DE_Gwaihir");
	optionsPanel.WorldList:AddItem("[DE] Maiar","_DE_Maiar");
	optionsPanel.WorldList:AddItem("[DE] Morthond","_DE_Morthond");
	optionsPanel.WorldList:AddItem("[DE] Vanyar","_DE_Vanyar");
	optionsPanel.WorldList:AddItem("[DE-RP] Belegaer","_DE_RP_Belegaer");
	optionsPanel.WorldList:AddItem("[EN] Eldar","_EN_Eldar");
	optionsPanel.WorldList:AddItem("[EN] Evernight","_EN_Evernight");
	optionsPanel.WorldList:AddItem("[EN] Gilrain","_EN_Gilrain");
	optionsPanel.WorldList:AddItem("[EN] Snowbourn","_EN_Snowbourn");
	optionsPanel.WorldList:AddItem("[EN] Withywindle","_EN_Withywindle");
	optionsPanel.WorldList:AddItem("[EN-RP] Laurelin","_EN_RP_Laurelin");
	optionsPanel.WorldList:AddItem("[FR] Sirannon","_FR_Sirannon");
	optionsPanel.WorldList:AddItem("[FR-RP] Estel","_FR_RP_Estel");

	optionsPanel.DefaultMapCaption=Turbine.UI.Label();
	optionsPanel.DefaultMapCaption:SetParent(optionsPanel);
	optionsPanel.DefaultMapCaption:SetPosition(10,optionsPanel.WorldCaption:GetTop()+optionsPanel.WorldCaption:GetHeight()+9);
	optionsPanel.DefaultMapCaption:SetSize(optionsPanel:GetWidth()-301,18);
	optionsPanel.DefaultMapCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.DefaultMapCaption:SetForeColor(fontColor);
	optionsPanel.DefaultMapCaption:SetText(Resource[language][200]..":");

	optionsPanel.DefaultMapList=GaranStuff.MoorMap.DropDownList();
	optionsPanel.DefaultMapList:SetParent(optionsPanel);
	optionsPanel.DefaultMapList:SetPosition(optionsPanel.DefaultMapCaption:GetLeft()+optionsPanel.DefaultMapCaption:GetWidth()+2,optionsPanel.DefaultMapCaption.GetTop()-3);
	optionsPanel.DefaultMapList:SetSize(optionsPanel:GetWidth()-(optionsPanel.DefaultMapCaption:GetWidth()+optionsPanel.DefaultMapCaption:GetLeft())-65,20);
	optionsPanel.DefaultMapList:SetBorderColor(trimColor);
	optionsPanel.DefaultMapList:SetBackColor(backColor);
	optionsPanel.DefaultMapList:SetCurrentBackColor(backColor);
	optionsPanel.DefaultMapList:SetDropRows(5);

	local tmpIndex;

	for tmpIndex=1,mapWindow.MapSelect.ListData:GetItemCount() do
		if mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue][11]==1 then
			optionsPanel.DefaultMapList:AddItem(mapWindow.MapSelect.ListData:GetItem(tmpIndex):GetText(),mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue)
		end
	end

-- trim color
	optionsPanel.TrimCaption=Turbine.UI.Label();
	optionsPanel.TrimCaption:SetParent(optionsPanel);
	optionsPanel.TrimCaption:SetPosition(10,optionsPanel.DefaultMapCaption:GetTop()+optionsPanel.DefaultMapCaption:GetHeight()+9);
	optionsPanel.TrimCaption:SetSize(optionsPanel:GetWidth()-301,18);
	optionsPanel.TrimCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.TrimCaption:SetForeColor(fontColor);
	optionsPanel.TrimCaption:SetText(Resource[language][6]..":");
	optionsPanel.TrimColor=GaranStuff.MoorMap.ColorPicker();
	optionsPanel.TrimColor:SetParent(optionsPanel);
	optionsPanel.TrimColor:SetPosition(optionsPanel.TrimCaption:GetLeft()+optionsPanel.TrimCaption:GetWidth()+5,optionsPanel.TrimCaption:GetTop()-1);
	optionsPanel.TrimColor:SetTrimColor(trimColor);
	optionsPanel.TrimColor:SetColor(trimColor);
	optionsPanel.TrimColor.ColorChanged=function()
		optionsPanel:SetTrimColor(optionsPanel.TrimColor:GetColor());
	end

	optionsPanel.BackCaption=Turbine.UI.Label();
	optionsPanel.BackCaption:SetParent(optionsPanel);
	optionsPanel.BackCaption:SetPosition(10,optionsPanel.TrimColor:GetTop()+optionsPanel.TrimColor:GetHeight()+9);
	optionsPanel.BackCaption:SetSize(optionsPanel:GetWidth()-301,18);
	optionsPanel.BackCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.BackCaption:SetForeColor(fontColor);
	optionsPanel.BackCaption:SetText(Resource[language][7]..":");
	optionsPanel.BackColor=GaranStuff.MoorMap.ColorPicker();
	optionsPanel.BackColor:SetParent(optionsPanel);
	optionsPanel.BackColor:SetPosition(optionsPanel.BackCaption:GetLeft()+optionsPanel.BackCaption:GetWidth()+5,optionsPanel.BackCaption:GetTop()-1);
	optionsPanel.BackColor:SetTrimColor(trimColor);
	optionsPanel.BackColor:SetColor(backColor);
	optionsPanel.BackColor.ColorChanged=function()
		optionsPanel:SetBackColor(optionsPanel.BackColor:GetColor());
	end

	optionsPanel.FontCaption=Turbine.UI.Label();
	optionsPanel.FontCaption:SetParent(optionsPanel);
	optionsPanel.FontCaption:SetPosition(10,optionsPanel.BackColor:GetTop()+optionsPanel.BackColor:GetHeight()+9);
	optionsPanel.FontCaption:SetSize(optionsPanel:GetWidth()-301,18);
	optionsPanel.FontCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.FontCaption:SetForeColor(fontColor);
	optionsPanel.FontCaption:SetText(Resource[language][8]..":"); --"Font Color:");
	optionsPanel.FontColor=GaranStuff.MoorMap.ColorPicker();
	optionsPanel.FontColor:SetParent(optionsPanel);
	optionsPanel.FontColor:SetPosition(optionsPanel.FontCaption:GetLeft()+optionsPanel.FontCaption:GetWidth()+5,optionsPanel.FontCaption:GetTop()-1);
	optionsPanel.FontColor:SetTrimColor(trimColor);
	optionsPanel.FontColor:SetColor(fontColor);
	optionsPanel.FontColor.ColorChanged=function()
		optionsPanel:SetFontColor(optionsPanel.FontColor:GetColor());
	end

	optionsPanel.HeadingsCaption=Turbine.UI.Label();
	optionsPanel.HeadingsCaption:SetParent(optionsPanel);
	optionsPanel.HeadingsCaption:SetPosition(10,optionsPanel.FontColor:GetTop()+optionsPanel.FontColor:GetHeight()+9);
	optionsPanel.HeadingsCaption:SetSize(optionsPanel:GetWidth()-301,18);
	optionsPanel.HeadingsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.HeadingsCaption:SetForeColor(fontColor);
	optionsPanel.HeadingsCaption:SetText(Resource[language][15]..":");
	optionsPanel.HeadingsColor=GaranStuff.MoorMap.ColorPicker();
	optionsPanel.HeadingsColor:SetParent(optionsPanel);
	optionsPanel.HeadingsColor:SetPosition(optionsPanel.HeadingsCaption:GetLeft()+optionsPanel.HeadingsCaption:GetWidth()+5,optionsPanel.HeadingsCaption:GetTop()-1);
	optionsPanel.HeadingsColor:SetTrimColor(trimColor);
	optionsPanel.HeadingsColor:SetColor(headingsColor);
	optionsPanel.HeadingsColor.ColorChanged=function()
		optionsPanel:SetHeadingsColor(optionsPanel.HeadingsColor:GetColor());
	end

	optionsPanel.ListTextCaption=Turbine.UI.Label();
	optionsPanel.ListTextCaption:SetParent(optionsPanel);
	optionsPanel.ListTextCaption:SetPosition(10,optionsPanel.HeadingsColor:GetTop()+optionsPanel.HeadingsColor:GetHeight()+9);
	optionsPanel.ListTextCaption:SetSize(optionsPanel:GetWidth()-301,18);
	optionsPanel.ListTextCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.ListTextCaption:SetForeColor(fontColor);
	optionsPanel.ListTextCaption:SetText(Resource[language][16]..":");
	optionsPanel.ListTextColor=GaranStuff.MoorMap.ColorPicker();
	optionsPanel.ListTextColor:SetParent(optionsPanel);
	optionsPanel.ListTextColor:SetPosition(optionsPanel.ListTextCaption:GetLeft()+optionsPanel.ListTextCaption:GetWidth()+5,optionsPanel.ListTextCaption:GetTop()-1);
	optionsPanel.ListTextColor:SetTrimColor(trimColor);
	optionsPanel.ListTextColor:SetColor(listTextColor);
	optionsPanel.ListTextColor.ColorChanged=function()
		optionsPanel:SetListTextColor(optionsPanel.ListTextColor:GetColor());
	end

	optionsPanel.ResetColors=Turbine.UI.Lotro.Button();
	optionsPanel.ResetColors:SetParent(optionsPanel);
	optionsPanel.ResetColors:SetSize(160,20);
	optionsPanel.ResetColors:SetPosition((optionsPanel:GetWidth()-optionsPanel.ResetColors:GetWidth())/2,optionsPanel.ListTextColor:GetTop()+optionsPanel.ListTextColor:GetHeight()+9);
	optionsPanel.ResetColors:SetText(Resource[language][9]);
	optionsPanel.ResetColors.Click=function()
		trimColor=Turbine.UI.Color(.2,.5,.9);
		fontColor=Turbine.UI.Color(1,.9,.5);
		backColor=Turbine.UI.Color(.05,.05,.05);
		headingsColor=Turbine.UI.Color(1,1,1);
		listTextColor=Turbine.UI.Color(1,1,1);
		optionsPanel.TrimColor:SetColor(trimColor);
		optionsPanel.FontColor:SetColor(fontColor);
		optionsPanel.BackColor:SetColor(backColor);
		optionsPanel.HeadingsColor:SetColor(headingsColor);
		optionsPanel.ListTextColor:SetColor(listTextColor);
	end

	optionsPanel.OpacityCaption=Turbine.UI.Label();
	optionsPanel.OpacityCaption:SetParent(optionsPanel);
	optionsPanel.OpacityCaption:SetPosition(10,optionsPanel.ResetColors:GetTop()+optionsPanel.ResetColors:GetHeight()+9);
	optionsPanel.OpacityCaption:SetSize(optionsPanel:GetWidth()-301,18);
	optionsPanel.OpacityCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.OpacityCaption:SetForeColor(fontColor);
	optionsPanel.OpacityCaption:SetText(Resource[language][71]..":");
	optionsPanel.OpacityScrollbar=Turbine.UI.Lotro.ScrollBar();
	optionsPanel.OpacityScrollbar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	optionsPanel.OpacityScrollbar:SetParent(optionsPanel)
	optionsPanel.OpacityScrollbar:SetPosition(optionsPanel.OpacityCaption:GetLeft()+optionsPanel.OpacityCaption:GetWidth()+5,optionsPanel.OpacityCaption:GetTop());
	optionsPanel.OpacityScrollbar:SetSize(optionsPanel:GetWidth()-optionsPanel.OpacityCaption:GetWidth()-optionsPanel.OpacityCaption:GetLeft()-15,10);
	optionsPanel.OpacityScrollbar:SetBackColor(Turbine.UI.Color(0,0,0));
	optionsPanel.OpacityScrollbar:SetMinimum(0);
	optionsPanel.OpacityScrollbar:SetMaximum(100);
	optionsPanel.OpacityScrollbar.OriginalValue=100;
	optionsPanel.OpacityScrollbar.ValueChanged=function()
		mapWindow.Map:SetOpacity(optionsPanel.OpacityScrollbar:GetValue()/100);
	end

-- **** There's a MAJOR BUG with checkboxes, they don't always change Checked value when you click IN the box, only on the label :(
-- so we implement the base checkbox class and provide our own image that we can forward mouse clicks on to here...
-- yeah, it's hokey, but it works as a place holder until Turbine fixes their Checkboxes


-- Load Minimized
	optionsPanel.LoadMinimizedCB=Turbine.UI.Lotro.CheckBox();
	optionsPanel.LoadMinimizedCB:SetParent(optionsPanel);
	optionsPanel.LoadMinimizedCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.LoadMinimizedCB:SetForeColor(fontColor);
	optionsPanel.LoadMinimizedCB:SetSize(optionsPanel:GetWidth()-15,18);
	optionsPanel.LoadMinimizedCB:SetPosition(10,optionsPanel.OpacityCaption:GetTop()+optionsPanel.OpacityCaption:GetHeight()+4);
	optionsPanel.LoadMinimizedCB:SetText(Resource[language][17]);

	optionsPanel.LMCBIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	optionsPanel.LMCBIcon:SetParent(optionsPanel);
	optionsPanel.LMCBIcon:SetSize(optionsPanel.LoadMinimizedCB:GetSize());
	optionsPanel.LMCBIcon:SetPosition(optionsPanel.LoadMinimizedCB:GetPosition());
	optionsPanel.LMCBIcon.MouseClick=function()
		optionsPanel.LoadMinimizedCB:SetChecked(not optionsPanel.LoadMinimizedCB:IsChecked());
	end
	optionsPanel.LMCBIcon:SetZOrder(optionsPanel.LoadMinimizedCB:GetZOrder()+1);

-- Show Icon when Minimized
	optionsPanel.ShowIconWhenMinimizedCB=Turbine.UI.Lotro.CheckBox();
	optionsPanel.ShowIconWhenMinimizedCB:SetParent(optionsPanel);
	optionsPanel.ShowIconWhenMinimizedCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.ShowIconWhenMinimizedCB:SetForeColor(fontColor);
	optionsPanel.ShowIconWhenMinimizedCB:SetSize(optionsPanel:GetWidth()-15,18);
	optionsPanel.ShowIconWhenMinimizedCB:SetPosition(10,optionsPanel.LoadMinimizedCB:GetTop()+optionsPanel.LoadMinimizedCB:GetHeight()+4);
	optionsPanel.ShowIconWhenMinimizedCB:SetText(Resource[language][18]);

	optionsPanel.SIWMCBIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	optionsPanel.SIWMCBIcon:SetParent(optionsPanel);
	optionsPanel.SIWMCBIcon:SetSize(optionsPanel.ShowIconWhenMinimizedCB:GetSize());
	optionsPanel.SIWMCBIcon:SetPosition(optionsPanel.ShowIconWhenMinimizedCB:GetPosition());
	optionsPanel.SIWMCBIcon.MouseClick=function()
		optionsPanel.ShowIconWhenMinimizedCB:SetChecked(not optionsPanel.ShowIconWhenMinimizedCB:IsChecked());
	end
	optionsPanel.SIWMCBIcon:SetZOrder(optionsPanel.ShowIconWhenMinimizedCB:GetZOrder()+1);

-- Use 16x16 Icon
	optionsPanel.UseMiniIconCB=Turbine.UI.Lotro.CheckBox();
	optionsPanel.UseMiniIconCB:SetParent(optionsPanel);
	optionsPanel.UseMiniIconCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.UseMiniIconCB:SetForeColor(fontColor);
	optionsPanel.UseMiniIconCB:SetSize(optionsPanel:GetWidth()-15,18);
	optionsPanel.UseMiniIconCB:SetPosition(10,optionsPanel.ShowIconWhenMinimizedCB:GetTop()+optionsPanel.ShowIconWhenMinimizedCB:GetHeight()+4);
	optionsPanel.UseMiniIconCB:SetText(Resource[language][201]);

	optionsPanel.UMICBIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	optionsPanel.UMICBIcon:SetParent(optionsPanel);
	optionsPanel.UMICBIcon:SetSize(optionsPanel.UseMiniIconCB:GetSize());
	optionsPanel.UMICBIcon:SetPosition(optionsPanel.UseMiniIconCB:GetPosition());
	optionsPanel.UMICBIcon.MouseClick=function()
		optionsPanel.UseMiniIconCB:SetChecked(not optionsPanel.UseMiniIconCB:IsChecked());
	end
	optionsPanel.UMICBIcon:SetZOrder(optionsPanel.UseMiniIconCB:GetZOrder()+1);

-- Mini Icon is opaque
	optionsPanel.MiniIconOpaqueCB=Turbine.UI.Lotro.CheckBox();
	optionsPanel.MiniIconOpaqueCB:SetParent(optionsPanel);
	optionsPanel.MiniIconOpaqueCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.MiniIconOpaqueCB:SetForeColor(fontColor);
	optionsPanel.MiniIconOpaqueCB:SetSize(optionsPanel:GetWidth()-15,18);
	optionsPanel.MiniIconOpaqueCB:SetPosition(30,optionsPanel.UseMiniIconCB:GetTop()+optionsPanel.UseMiniIconCB:GetHeight()+4);
	optionsPanel.MiniIconOpaqueCB:SetText(Resource[language][202]);

	optionsPanel.UMICBIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	optionsPanel.UMICBIcon:SetParent(optionsPanel);
	optionsPanel.UMICBIcon:SetSize(optionsPanel.MiniIconOpaqueCB:GetSize());
	optionsPanel.UMICBIcon:SetPosition(optionsPanel.MiniIconOpaqueCB:GetPosition());
	optionsPanel.UMICBIcon.MouseClick=function()
		optionsPanel.MiniIconOpaqueCB:SetChecked(not optionsPanel.MiniIconOpaqueCB:IsChecked());
	end
	optionsPanel.UMICBIcon:SetZOrder(optionsPanel.MiniIconOpaqueCB:GetZOrder()+1);

-- Show Quick Annotation control
	optionsPanel.ShowQuickAnnotCB=Turbine.UI.Lotro.CheckBox();
	optionsPanel.ShowQuickAnnotCB:SetParent(optionsPanel);
	optionsPanel.ShowQuickAnnotCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.ShowQuickAnnotCB:SetForeColor(fontColor);
	optionsPanel.ShowQuickAnnotCB:SetSize(optionsPanel:GetWidth()-15,18);
	optionsPanel.ShowQuickAnnotCB:SetPosition(10,optionsPanel.MiniIconOpaqueCB:GetTop()+optionsPanel.MiniIconOpaqueCB:GetHeight()+4);
	optionsPanel.ShowQuickAnnotCB:SetText(Resource[language][160]);

	optionsPanel.SQACBIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	optionsPanel.SQACBIcon:SetParent(optionsPanel);
	optionsPanel.SQACBIcon:SetSize(optionsPanel.ShowQuickAnnotCB:GetSize());
	optionsPanel.SQACBIcon:SetPosition(optionsPanel.ShowQuickAnnotCB:GetPosition());
	optionsPanel.SQACBIcon.MouseClick=function()
		optionsPanel.ShowQuickAnnotCB:SetChecked(not optionsPanel.ShowQuickAnnotCB:IsChecked());
	end
	optionsPanel.SQACBIcon:SetZOrder(optionsPanel.ShowQuickAnnotCB:GetZOrder()+1);

	optionsPanel.QAOpacityCaption=Turbine.UI.Label();
	optionsPanel.QAOpacityCaption:SetParent(optionsPanel);
	optionsPanel.QAOpacityCaption:SetPosition(10,optionsPanel.ShowQuickAnnotCB:GetTop()+optionsPanel.ShowQuickAnnotCB:GetHeight()+9);
	optionsPanel.QAOpacityCaption:SetSize(optionsPanel:GetWidth()-301,18);
	optionsPanel.QAOpacityCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.QAOpacityCaption:SetForeColor(fontColor);
	optionsPanel.QAOpacityCaption:SetText(Resource[language][161]..":");
	optionsPanel.QAOpacityScrollbar=Turbine.UI.Lotro.ScrollBar();
	optionsPanel.QAOpacityScrollbar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	optionsPanel.QAOpacityScrollbar:SetParent(optionsPanel)
	optionsPanel.QAOpacityScrollbar:SetPosition(optionsPanel.QAOpacityCaption:GetLeft()+optionsPanel.QAOpacityCaption:GetWidth()+5,optionsPanel.QAOpacityCaption:GetTop());
	optionsPanel.QAOpacityScrollbar:SetSize(optionsPanel:GetWidth()-optionsPanel.QAOpacityCaption:GetWidth()-optionsPanel.QAOpacityCaption:GetLeft()-15,10);
	optionsPanel.QAOpacityScrollbar:SetBackColor(Turbine.UI.Color(0,0,0));
	optionsPanel.QAOpacityScrollbar:SetMinimum(0);
	optionsPanel.QAOpacityScrollbar:SetMaximum(100);
	optionsPanel.QAOpacityScrollbar.OriginalValue=15;
	optionsPanel.QAOpacityScrollbar.ValueChanged=function()
		quickWindow:SetOpacity(optionsPanel.QAOpacityScrollbar:GetValue()/100);
	end

-- Other Options ?
	optionsPanel.DebugCB=Turbine.UI.Lotro.CheckBox();
	optionsPanel.DebugCB:SetParent(optionsPanel);
	optionsPanel.DebugCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsPanel.DebugCB:SetForeColor(fontColor);
	optionsPanel.DebugCB:SetSize(optionsPanel:GetWidth()-15,18);
	optionsPanel.DebugCB:SetPosition(10,optionsPanel.QAOpacityCaption:GetTop()+optionsPanel.QAOpacityCaption:GetHeight()+4);
	optionsPanel.DebugCB:SetText("Debug");

	optionsPanel.DebugIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	optionsPanel.DebugIcon:SetParent(optionsPanel);
	optionsPanel.DebugIcon:SetSize(optionsPanel.DebugCB:GetSize());
	optionsPanel.DebugIcon:SetPosition(optionsPanel.DebugCB:GetPosition());
	optionsPanel.DebugIcon.MouseClick=function()
		optionsPanel.DebugCB:SetChecked(not optionsPanel.DebugCB:IsChecked());
	end
	optionsPanel.DebugIcon:SetZOrder(optionsPanel.DebugCB:GetZOrder()+1);

--** SAVE AND CANCEL
	optionsPanel.SaveButton=Turbine.UI.Lotro.Button();
	optionsPanel.SaveButton:SetParent(optionsPanel);
	optionsPanel.SaveButton:SetSize(100,20);
	optionsPanel.SaveButton:SetPosition(20,optionsPanel:GetHeight()-40);
	optionsPanel.SaveButton:SetText(Resource[language][11]);
	optionsPanel.SaveButton.Click=function()
		local hasError=false;
		-- validate option values

		if hasError then
			optionsPanel.ErrorLabel:SetVisible(true);
			optionsPanel.HadErrors=true;
			optionsPanel.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
			optionsPanel:SetWantsUpdates(true);
		else
			debug=optionsPanel.DebugCB:IsChecked();
			if debug then debugWindow:SetVisible(true) end
			rb=optionsPanel.LoadMinimizedCB:IsChecked();
			mapWindow:SetLoadMinimized(rb);
			rb=optionsPanel.ShowIconWhenMinimizedCB:IsChecked();
			mapWindow:SetShowIconWhenMinimized(rb);
			minWindow:SetUseMiniIcon(optionsPanel.UseMiniIconCB:IsChecked());
			minWindow:SetMiniIconOpaque(optionsPanel.MiniIconOpaqueCB:IsChecked());
			quickWindow.Displayed=optionsPanel.ShowQuickAnnotCB:IsChecked();
			quickWindow:SetVisible(quickWindow.Displayed);
			quickWindow.Opacity=optionsPanel.QAOpacityScrollbar:GetValue()/100;

			fontColor=optionsPanel.FontColor:GetColor();
			trimColor=optionsPanel.TrimColor:GetColor();
			backColor=optionsPanel.BackColor:GetColor();
			headingsColor=optionsPanel.HeadingsColor:GetColor();
			listTextColor=optionsPanel.ListTextColor:GetColor();

			local newLanguage=optionsPanel.LanguageList:GetValue();

			mapWindow:SetFontColor();
			mapWindow:SetTrimColor();
			mapWindow:SetBackColor();
			mapWindow:SetHeadingsColor();
			mapWindow:SetLanguage();
			mapWindow:SetListTextColor();

			local newWorldName=optionsPanel.WorldList:GetValue();
			defaultMap=optionsPanel.DefaultMapList:GetValue();
			if newLanguage~=language or (worldName~=newWorldName and mapWindow.CurrentMapID==1) then
				language=newLanguage;
				worldName=newWorldName;
				mapWindow.PreserveMapID=true;
				-- load the plugin that will unload and reload this plugin (we can only read the annotation files without a 15 second delay while we are "loading")
				Turbine.PluginManager.LoadPlugin("MoorMapLoader");
			else
				worldName=newWorldName;
				annotWindow:SetLanguage();
				annotWindow:LoadAnnotationList(); -- force reload of the translated values
				mapWindow.Map.IconSearch.OldText=tostring(mapWindow.Map.IconSearch.OldText).."X"; -- any change to the old text will force a refresh in case there was a filter applied
				mapWindow.NeedsRefresh=true;
				mapWindow:SetWantsUpdates(true); -- will reload all map components, including icon search list
			end
		end
	end

	optionsPanel.CancelButton=Turbine.UI.Lotro.Button();
	optionsPanel.CancelButton:SetParent(optionsPanel);
	optionsPanel.CancelButton:SetSize(100,20);
	optionsPanel.CancelButton:SetPosition(optionsPanel:GetWidth()-20-optionsPanel.CancelButton:GetWidth(),optionsPanel:GetHeight()-40);
	optionsPanel.CancelButton:SetText(Resource[language][12]);
	optionsPanel.CancelButton.Click=function()
		mapWindow.Map:SetOpacity(optionsPanel.OpacityScrollbar.OriginalValue);
		quickWindow:SetOpacity(optionsPanel.QAOpacityScrollbar.OriginalValue);
		optionsPanel.FontColor:SetColor(fontColor);
		optionsPanel.TrimColor:SetColor(trimColor);
		optionsPanel.BackColor:SetColor(backColor);
		optionsPanel.HeadingsColor:SetColor(headingsColor);
	end

	optionsPanel.ErrorLabel=Turbine.UI.Label();
	optionsPanel.ErrorLabel:SetParent(optionsPanel);
	optionsPanel.ErrorLabel:SetText("Adjusted Invalid Values")
	optionsPanel.ErrorLabel:SetPosition(optionsPanel.SaveButton:GetLeft()+optionsPanel.SaveButton:GetWidth(),optionsPanel.SaveButton:GetTop());
	optionsPanel.ErrorLabel:SetSize(optionsPanel.CancelButton:GetLeft()-(optionsPanel.ErrorLabel:GetLeft()),optionsPanel.SaveButton:GetHeight());
	optionsPanel.ErrorLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	optionsPanel.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
	optionsPanel.ErrorLabel:SetVisible(false);
	optionsPanel.ErrorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

	optionsPanel.DefaultMapList:SetZOrder(optionsPanel.ErrorLabel:GetZOrder()+1)
	optionsPanel.WorldList:SetZOrder(optionsPanel.DefaultMapList:GetZOrder()+1);
	optionsPanel.LanguageList:SetZOrder(optionsPanel.WorldList:GetZOrder()+1);

	optionsPanel.Update=function(sender,args)
		if optionsPanel.HadErrors then
			if Turbine.Engine:GetGameTime()>optionsPanel.ErrorFadeTime then
				optionsPanel:SetWantsUpdates(false);
				optionsPanel.ErrorLabel:SetVisible(false);
				optionsPanel.HadErrors=false
			end
		end
	end
	optionsPanel.SetTrimColor=function(sender,color)
		optionsPanel.LanguageList:SetBorderColor(color);
		optionsPanel.FontColor:SetTrimColor(color);
		optionsPanel.TrimColor:SetTrimColor(color);
		optionsPanel.BackColor:SetTrimColor(color);
		optionsPanel.HeadingsColor:SetTrimColor(color);
		optionsPanel.ListTextColor:SetTrimColor(color);
	end
	optionsPanel.SetBackColor=function(sender,color)
		optionsPanel.LanguageList:SetBackColor(color);
		optionsPanel.LanguageList:SetCurrentBackColor(color);
		optionsPanel:SetBackColor(color);
		optionsPanel.FontColor:SetBackColor(color);
		optionsPanel.TrimColor:SetBackColor(color);
		optionsPanel.BackColor:SetBackColor(color);
		optionsPanel.HeadingsColor:SetBackColor(color);
		optionsPanel.ListTextColor:SetBackColor(color);
	end
	optionsPanel.SetFontColor=function(sender,color)
		optionsPanel.LanguageCaption:SetForeColor(color);
		optionsPanel.WorldCaption:SetForeColor(color);
		optionsPanel.DefaultMapCaption:SetForeColor(color);
		optionsPanel.LoadMinimizedCB:SetForeColor(color);
		optionsPanel.ShowIconWhenMinimizedCB:SetForeColor(color);
		optionsPanel.UseMiniIconCB:SetForeColor(color);
		optionsPanel.MiniIconOpaqueCB:SetForeColor(color);
		optionsPanel.TrimCaption:SetForeColor(color);
		optionsPanel.FontCaption:SetForeColor(color);
		optionsPanel.BackCaption:SetForeColor(color);
		optionsPanel.HeadingsCaption:SetForeColor(color);
		optionsPanel.ListTextCaption:SetForeColor(color);
		optionsPanel.OpacityCaption:SetForeColor(color);
	end
	optionsPanel.SetHeadingsColor=function(sender,color)
		optionsPanel.OptionsCaption:SetForeColor(color);
	end
	optionsPanel.SetListTextColor=function(sender,color)
		optionsPanel.LanguageList:SetTextColor(color);
	end

	optionsPanel.SetLanguage=function(sender,tmpLanguage)
		optionsPanel.OptionsCaption:SetText(Resource[tmpLanguage][4]..":");
		optionsPanel.LanguageCaption:SetText(Resource[tmpLanguage][5]..":");
		optionsPanel.WorldCaption:SetText(Resource[tmpLanguage][149]..":");
		optionsPanel.DefaultMapCaption:SetText(Resource[tmpLanguage][200]..":");
		optionsPanel.TrimCaption:SetText(Resource[tmpLanguage][6]..":");
		optionsPanel.BackCaption:SetText(Resource[tmpLanguage][7]..":");
		optionsPanel.FontCaption:SetText(Resource[tmpLanguage][8]..":");
		optionsPanel.HeadingsCaption:SetText(Resource[tmpLanguage][15]..":");
		optionsPanel.ListTextCaption:SetText(Resource[tmpLanguage][16]..":");
		optionsPanel.ResetColors:SetText(Resource[tmpLanguage][9]);
		optionsPanel.OpacityCaption:SetText(Resource[tmpLanguage][71]..":");

		optionsPanel.LoadMinimizedCB:SetText(Resource[tmpLanguage][17]);
		optionsPanel.ShowIconWhenMinimizedCB:SetText(Resource[tmpLanguage][18]);
		optionsPanel.UseMiniIconCB:SetText(Resource[tmpLanguage][201]);
		optionsPanel.MiniIconOpaqueCB:SetText(Resource[tmpLanguage][202]);
		optionsPanel.ShowQuickAnnotCB:SetText(Resource[tmpLanguage][160]);
		optionsPanel.QAOpacityCaption:SetText(Resource[tmpLanguage][161]..":");

		optionsPanel.SaveButton:SetText(Resource[tmpLanguage][11]);
		optionsPanel.CancelButton:SetText(Resource[tmpLanguage][12]);
	end

	-- refresh the options status to reflect current values
	optionsPanel.OpacityScrollbar:SetValue(math.floor(mapWindow.Map:GetOpacity()*100));
	optionsPanel.OpacityScrollbar.OriginalValue=mapWindow.Map:GetOpacity();
	optionsPanel.QAOpacityScrollbar:SetValue(math.floor(quickWindow:GetOpacity()*100));
	optionsPanel.QAOpacityScrollbar.OriginalValue=quickWindow:GetOpacity();
	optionsPanel.LoadMinimizedCB:SetChecked(mapWindow:GetLoadMinimized());
	optionsPanel.ShowIconWhenMinimizedCB:SetChecked(mapWindow:GetShowIconWhenMinimized());
	optionsPanel.UseMiniIconCB:SetChecked(minWindow:GetUseMiniIcon());
	optionsPanel.MiniIconOpaqueCB:SetChecked(minWindow:GetMiniIconOpaque());
	optionsPanel.ShowQuickAnnotCB:SetChecked(quickWindow.Displayed);
	optionsPanel.DebugCB:SetChecked(debug);

	local index;
	for index=1,optionsPanel.LanguageList.ListData:GetItemCount() do
		if optionsPanel.LanguageList.ListData:GetItem(index):GetValue()==language then
			optionsPanel.LanguageList:SetSelectedIndex(index);
			break;
		end
	end
	for index=1,optionsPanel.WorldList.ListData:GetItemCount() do
		if optionsPanel.WorldList.ListData:GetItem(index).DataValue==worldName then
			optionsPanel.WorldList:SetSelectedIndex(index);
			break;
		end
	end
	for index=1,optionsPanel.DefaultMapList.ListData:GetItemCount() do
		if optionsPanel.DefaultMapList.ListData:GetItem(index):GetValue()==defaultMap then
			optionsPanel.DefaultMapList:SetSelectedIndex(index);
			break;
		end
	end
	optionsPanel:SetLanguage(language);

plugin.GetOptionsPanel = function( self )
  return optionsPanel;
end
